<template>
    <div class="branch-container q-px-lg-xl q-pb-lg-xl q-px-xs-none scrollable-card-y">
        <div class="row justify-start item-center q-mt-lg">
            <div class="col-12 col-md-8 q-ml-md-md font-18 text-black q-mt-xs">
                <q-btn flat no-caps @click="selectCurrentPage(1)">
                    <q-icon name="arrow_back" color="black" size="25px" />
                    <span class="font-18 helvetica-neue-medium q-pl-md">
                        {{ $t('branch.createBranch') }}
                    </span>
                </q-btn>
            </div>
            <div class="col-12 col-md-3 col-lg-3 items-center">
                <q-btn
                    no-caps
                    text-color="white"
                    class="
                        button-save
                        desktop-save
                        float-right
                        helvetica-neue-medium
                    "
                    @click="createBranch"
                    :label="$t('button.save')"
                />
            </div>
        </div>
        <div
            class="
                row
                justify-start
                items-center
                q-py-lg q-px-xs-lg q-px-sm-lg q-mt-xl
            "
        >
            <div class="col-md-2 col-12 q-mt-xs items-center q-mr-md">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('branch.name') }}
                    <span class="text-ff0000 font-10" v-if="!state.branchName">
                        {{ $t('form.required') }}
                    </span>
                </p>
                <q-input
                    outlined
                    :dense="dense"
                    v-model="state.branchName"
                    bg-color="blue-2"
                    class="border-radius-20"
                ></q-input>
            </div>
            <div class="col-md-2 col-12 q-mt-xs items-center q-mr-md">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('branch.codeName') }}
                    <span class="text-ff0000 font-10" v-if="!state.codeName">
                        {{ $t('form.required') }}
                    </span>
                </p>
                <q-input
                    outlined
                    :dense="dense"
                    v-model="state.codeName"
                    bg-color="blue-2"
                    class="border-radius-20"
                ></q-input>
            </div>
            <div class="col-md-2 col-12 q-mt-xs items-center q-mr-md">
                <p class="font-14 q-mb-md helvetica-neue-medium">
                    {{ $t('branch.contact') }}
                </p>
                <q-input
                    outlined
                    :dense="dense"
                    v-model="state.contact"
                    bg-color="blue-2"
                    class="border-radius-20"
                ></q-input>
            </div>

            <!-- BUTTONS -->
            <div
                class="
                    col-5 col-xs-12 col-sm-5 col-md-5 col-lg-5
                    q-pt-md-none q-pt-sm-none q-pt-xs-lg
                    self-end
                "
            >
                <q-btn
                    no-caps
                    text-color="white"
                    class="
                        button-deactive
                        helvetica-neue-medium
                        row
                        justify-center
                    "
                    :label="$t('button.deactivate')"
                    @click="openDeactivate()"
                />
            </div>
        </div>

        <div class="row q-px-xs-lg q-px-sm-lg">
            <div class="row col-12 col-md-7 col-lg-8">
                <!-- AVATAR COLUMN -->
                <div class="col-5 col-xs-6 col-sm-6 col-md-6 col-lg-5">
                    <div
                        class="
                            label-title
                            col-12
                            items-left
                            font-14
                            text-black
                            helvetica-neue-medium
                        "
                    >
                        {{ $t('preference.avatar') }}
                    </div>
                    <div class="col-12 row q-mt-md">
                        <q-btn
                            no-caps
                            text-color="white"
                            class="button-primary helvetica-neue-medium font-16"
                            label="Change avatar"
                            @click="openUploadImage(1)"
                        />
                        <span
                            class="
                                helvetica-neue-medium
                                font-16
                                text-FA6767
                                row
                                items-center
                                q-ml-lg
                                remove-text
                            "
                        >
                            Remove avatar
                        </span>
                    </div>
                </div>

                <!-- COVER IMAGE COLUMN -->
                <div class="col-6">
                    <div
                        class="
                            label-title
                            col-12
                            items-left
                            font-14
                            text-black
                            helvetica-neue-medium
                        "
                    >
                        {{ $t('preference.coverImage') }}
                    </div>
                    <div class="col-12 row q-mt-md">
                        <q-btn
                            no-caps
                            text-color="white"
                            class="button-primary helvetica-neue-medium font-16"
                            label="Change cover image"
                            @click="openUploadImage(2)"
                        />
                        <span
                            class="
                                helvetica-neue-medium
                                font-16
                                text-FA6767
                                row
                                items-center
                                q-ml-lg
                                remove-text
                            "
                        >
                            Remove cover image
                        </span>
                    </div>
                </div>

                <!-- ABOUT BUSINESS -->
                <div class="col-12 col-md-12 col-lg-6">
                    <div
                        class="
                            label-title
                            col-12
                            q-mt-sm q-mb-md q-mt-xs-lg q-mt-sm-lg
                            items-left
                            font-14
                            text-black
                            helvetica-neue-medium
                        "
                    >
                        {{ $t('branch.address') }}
                    </div>
                    <div class="col-12 row business-textbox">
                        <q-input
                            v-model="state.address"
                            type="textarea"
                            counter
                            autogrow
                            maxlength="150"
                            disable
                            class="text-business q-pa-sm"
                        />
                    </div>
                </div>
                <div class="col-12 col-md-12 col-lg-6 q-pl-md-lg">
                    <div
                        class="
                            label-title
                            col-12
                            q-mt-sm q-mb-md q-mt-xs-lg q-mt-sm-lg
                            items-left
                            font-14
                            text-black
                            helvetica-neue-medium
                        "
                    >
                        {{ $t('branch.about') }}
                    </div>
                    <div class="col-12 row business-textbox">
                        <q-input
                            v-model="state.description"
                            label="Tell the world about your company"
                            type="textarea"
                            counter
                            autogrow
                            maxlength="150"
                            class="text-business q-pa-sm"
                        />
                    </div>
                    <div
                        class="
                            col-12 col-md-3 col-lg-3
                            q-mt-xs-lg q-mt-sm-lg
                            items-center
                        "
                    >
                        <q-btn
                            no-caps
                            text-color="white"
                            class="
                                button-save
                                mobile-save
                                float-right
                                helvetica-neue-medium
                            "
                            :label="$t('button.save')"
                        />
                    </div>
                </div>
            </div>
        </div>
        <upload-image v-model="state.confirm" @update-confirm="updateConfirm" />
        <deactivate
            v-model="state.confirm2"
            @update-confirm2="updateConfirm2"
        />
    </div>
</template>
<script lang="ts">
import UploadImage from '../modals/UploadImage.vue';
import Deactivate from '../modals/Deactivate.vue';
import { useStore } from 'src/store';
import { defineComponent, ref, reactive, computed, watch } from 'vue';

export default defineComponent({
    name: 'CreateBranch',
    props: {
        label: {
            type: Object,
            required: false
        }
    },
    components: {
        UploadImage,
        Deactivate
    },
    setup(props, { emit }) {
        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        let state = reactive({
            currentPage: 'default',
            label: {} as any,
            loadingState: ref(false),
            toggleValue: {} as any,
            permissionList: [] as any,
            lists: [] as any,
            branch: [] as any,
            permissionOrder: '',
            type: 0,
            imagePath: '' as any,
            coverPath: '' as any,
            confirm: ref(false),
            confirm2: ref(false),
            codeName: '' as any,
            name: '' as any,
            branchName: '' as any,
            contact: '' as any,
            path: '' as any,
            address: '' as any,
            description: '' as any,
            permissions: computed(() => { return store.state.role.permissions; }),
        });
        const store = useStore();

        watch(selectedBusinessId, () => {
            if (selectedBusinessId.value) {
                selectCurrentPage(1);
            }
        });
        const selectCurrentPage = (page: any) => {
            emit('update-branch', page);
        };

        const openUploadImage = (type: number) => {
            state.type = type;
            state.confirm = true;
        };

        const updateConfirm = (value: any, image: any) => {
            state.confirm = value;
            state.path = image;

            if (state.type == 1) {
                state.imagePath = state.path;
                state.path = '';
            } else {
                state.coverPath = state.path;
                state.path = '';
            }
        };
        const updateConfirm2 = (value: any, type: any) => {
            state.confirm2 = value;
            state.path = type;
            if (type == 1) {
                disableView();
            }
        };

        const disableView = () => {
            let query = ['helpdesk', 'attendance'];
            query.forEach((list: any) => {
                const result = store.dispatch('business/disableBusiness', list);
            });
            store.dispatch('business/getBusinesses');
        };

        const createBranch = async () => {
            if(state.permissions?.branch?.create == true) {
                const res = await store.dispatch('branch/createBranch', {
                    name: state.branchName,
                    slug: state.codeName,
                    imagePath: state.imagePath,
                    coverPath: state.coverPath,
                    description: state.description,
                    tag: [],
                    status: 1,
                    contacts: [{ type: 'phone', value: state.contact }]
                });

                if (res.status == 200) {
                    selectCurrentPage(1);
                }
            }
        };

        const openDeactivate = () => {
            console.log('deactivate');
        };

        return {
            state,
            store,
            selectCurrentPage,
            dense: ref(true),
            openUploadImage,
            updateConfirm,
            updateConfirm2,
            disableView,
            createBranch,
            openDeactivate
        };
    }
});
</script>
